/**
 * @file
 * Billwerk behaviors.
 */
(function (Drupal, drupalSettings) {
  "use strict";

  Drupal.behaviors.billwerkSubscriptionjsInit = {
    // @todo: Implement!
    attach(context, settings) {
      if (context === document) {
        Drupal.billwerk = {};
        Drupal.billwerk.subscriptionjs = {};

        // Drupal.billwerk.subscriptionjs.payment =
        Drupal.billwerk.subscriptionjs.portalService =
          new SubscriptionJS.Portal(settings.billwerk.selfserviceToken);

        SubscriptionJS.createElement(
          "paymentForm",
          document.getElementById("subscriptionjs-wrapper"),
          {
            // @todo:
            paymentMethods: ["Debit:FakePSP", "CreditCard:FakePSP"],
            publicApiKey: settings.billwerk.selfservicePublicApiKey,
            locale: "en",
            providerReturnUrl: "https://your_domain.com/your_finalize_page",
          },
          {},
          console.error,
        );

        console.log(settings.billwerk.selfserviceToken);
        console.log(settings.billwerk.selfservicePublicApiKey);
        console.log(settings.billwerk.orderId);

        Drupal.billwerk.subscriptionjs.portalService.upgradePaySync(
          settings.billwerk.orderId,
          console.log,
          console.error,
        );

        // console.log(Drupal.billwerk.subscriptionjs.portalService);
        Drupal.billwerk.subscriptionjs.portalService.contractDetails(
          console.log,
          console.error,
        );

        // Drupal.billwerk.subscriptionjs.upgradePay = function(){

        // };

        // Drupal.billwerk.subscriptionjs.paymentService =
        //   new SubscriptionJS.Payment({
        //     publicApiKey: drupalSettings.billwerk.publicApiKey,
        //   });

        // Get all contract details:
        // console.log(Drupal.billwerk.subscriptionjs.portalService.contractDetails(console.log, console.error));
      }
    },
  };
})(Drupal, drupalSettings);
